##### Overview

- Download PMD 3.7
- What's new in PMD 3.7
- PMD in the news
- PMD-related products and books
- Best practices
- Future directions
- Similar projects
- Credits
- License
- What does 'PMD' mean?

##### Usage

- Installation
- Command line usage
- Ant task usage
- Maven plugin usage
- IDE plugin usage
- Suppressing warnings
- Finding duplicated code
- JSP support

##### Customizing PMD

- Compiling PMD
- How to write a rule
- Writing XPath rules
- How to make a rule set
- How it works

##### For example

- Run PMD on a Sourceforge project

##### Rule Sets

- Index
- Basic
- Braces
- Code Size
- Clone
- Controversial
- Coupling
- Design
- Finalizers
- Import Statements
- J2EE
- Javabeans
- JUnit Tests
- Logging (Java)
- Logging (Jakarta)
- Migrating
- Naming
- Optimizations
- Strict Exceptions
- Strings
- Sun Security
- Unused Code
- Java Server Pages
- Java Server Faces

##### Project Documentation

- About PMD
- Project Info
- Project Reports
  - JavaDocs
  - JavaDoc Report
  - Source Xref
  - Test Xref
  - Unit Tests
  - Clover
  - File Activity
  - Developer Activity
  - FAQs
  - PMD Report
- Development Process

## Maven Generated Reports

This document provides an overview of the various reports that are automatically generated by Maven. Each report is briefly described below.

### Overview

Document | Description
--- | ---
JavaDocs | JavaDoc API documentation.
JavaDoc Report | Report on the generation of JavaDoc.
Source Xref | A set of browsable cross-referenced sources.
Test Xref | A set of browsable cross-referenced test sources.
Unit Tests | Report on the results of the unit tests.
Clover | Clover test coverage report.
File Activity | Report on file activity.
Developer Activity | Report on the amount of developer activity.
FAQs | Frequently Asked Questions.
PMD Report | Verification of coding rules.